/*
 *  The Mana Client
 *  Copyright (C) 2004-2009  The Mana World Development Team
 *  Copyright (C) 2009-2010  The Mana Developers
 *
 *  This file is part of The Mana Client.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "net/ea/chathandler.h"

#include "being.h"
#include "beingmanager.h"
#include "configuration.h"
#include "game.h"
#include "localplayer.h"
#include "playerrelations.h"
#include "log.h"

#include "gui/chat.h"
#include "gui/shopwindow.h"

#include "gui/widgets/chattab.h"

#include "net/messagein.h"
#include "net/messageout.h"

#include "net/ea/protocol.h"

#include "utils/gettext.h"
#include "utils/stringutils.h"

#include <string>

extern Net::ChatHandler *chatHandler;

namespace EAthena {

ChatHandler::ChatHandler()
{
    static const Uint16 _messages[] = {
        SMSG_BEING_CHAT,
        SMSG_PLAYER_CHAT,
        SMSG_WHISPER,
        SMSG_WHISPER_RESPONSE,
        SMSG_GM_CHAT,
        SMSG_MVP, // MVP
        0
    };
    handledMessages = _messages;
    chatHandler = this;
}

void ChatHandler::handleMessage(Net::MessageIn &msg)
{
    if (!localChatTab) return;

    Being *being;
    std::string chatMsg;
    std::string nick;
    int chatMsgLength;

    switch (msg.getId())
    {
        case SMSG_WHISPER_RESPONSE:
        {
            int type = msg.readInt8();
            switch (type)
            {
                case 0x00:
                    // comment out since we'll local echo in chat.cpp instead, then only report failures
                    //localChatTab->chatLog("Whisper sent", ChatTab::BY_SERVER);
                    break;
                case 0x01:
                    if (localChatTab)
                        localChatTab->chatLog(_("Whisper could not be sent, user "
                                                "is offline."), ChatTab::BY_SERVER);
                    break;
                case 0x02:
                    if (localChatTab)
                        localChatTab->chatLog(_("Whisper could not be sent, "
                                                "ignored by user."), ChatTab::BY_SERVER);
                    break;
                default:
                    if (logger)
                        logger->log("QQQ SMSG_WHISPER_RESPONSE:" + toString(type));
            }
            break;
        }

        // Received whisper
        case SMSG_WHISPER:
            chatMsgLength = msg.readInt16() - 28;
            nick = msg.readString(24);

            if (chatMsgLength <= 0)
                break;

            chatMsg = msg.readString(chatMsgLength);

            if (nick != "Server")
            {
                if (player_relations.hasPermission(nick, PlayerRelation::WHISPER))
                {
                    if (player_relations.hasPermission(
                            nick, PlayerRelation::TRADE)
                        && config.getValue("tradebot", true))
                    {
                        if (shopWindow)
                        {   //commands to shop from player
                            if (chatMsg.find("!selllist ") == 0)
                            {
                                shopWindow->giveList(nick, ShopWindow::SELL);
                            }
                            else if (chatMsg.find("!buylist ") == 0)
                            {
                                shopWindow->giveList(nick, ShopWindow::BUY);
                            }
                            else if (chatMsg.find("!buyitem ") == 0)
                            {
                                shopWindow->processRequest(nick, chatMsg,
                                        ShopWindow::BUY);
                            }
                            else if (chatMsg.find("!sellitem ") == 0)
                            {
                                shopWindow->processRequest(nick, chatMsg,
                                        ShopWindow::SELL);
                            }
                            else if (chatMsg.length() > 3
                                     && chatMsg.find("\302\202") == 0)
                            {
                                chatMsg = chatMsg.erase(0, 2);
                                if (chatMsg.find("B1") == 0
                                    || chatMsg.find("S1") == 0)
                                {
                                    shopWindow->showList(nick, chatMsg);
                                }
                            }
                        }
                    }
                    if (chatWindow)
                        chatWindow->whisper(nick, chatMsg);
                }
            }
            else if (localChatTab)
            {
                localChatTab->chatLog(chatMsg, ChatTab::BY_SERVER);
            }

            break;

        // Received speech from being
        case SMSG_BEING_CHAT: {
            chatMsgLength = msg.readInt16() - 8;
            being = beingManager->findBeing(msg.readInt32());

            if (!being || chatMsgLength <= 0)
                break;

            chatMsg = msg.readString(chatMsgLength);

            if (being->getType() == Being::PLAYER)
                dynamic_cast<Player *>(being)->setTalkTime();

            std::string::size_type pos = chatMsg.find(" : ", 0);
            std::string sender_name = ((pos == std::string::npos)
                                       ? ""
                                       : chatMsg.substr(0, pos));

            // We use getIgnorePlayer instead of ignoringPlayer here because ignorePlayer' side
            // effects are triggered right below for Being::IGNORE_SPEECH_FLOAT.
            if (player_relations.checkPermissionSilently(sender_name, PlayerRelation::SPEECH_LOG)
                && localChatTab)
            {
                if (chatWindow)
                    chatWindow->resortChatLog(chatMsg, ChatTab::BY_OTHER);
//                localChatTab->chatLog(chatMsg, ChatTab::BY_OTHER);
            }

            chatMsg.erase(0, pos + 3);
            trim(chatMsg);

            if (player_relations.hasPermission(sender_name, PlayerRelation::SPEECH_FLOAT))
                being->setSpeech(chatMsg, SPEECH_TIME);
            break;
        }

        case SMSG_PLAYER_CHAT:
        case SMSG_GM_CHAT: {
            chatMsgLength = msg.readInt16() - 4;

            if (chatMsgLength <= 0)
                break;

            chatMsg = msg.readString(chatMsgLength);
            std::string::size_type pos = chatMsg.find(" : ", 0);

            if (msg.getId() == SMSG_PLAYER_CHAT)
            {
                if (chatWindow)
                    chatWindow->resortChatLog(chatMsg, ChatTab::BY_PLAYER);
//                if (localChatTab)
//                    localChatTab->chatLog(chatMsg, ChatTab::BY_PLAYER);

                const std::string senseStr = "You sense the following: ";
                if (beingManager && !chatMsg.find(senseStr))
                    beingManager->parseLevels(chatMsg.substr(senseStr.size()));

                if (pos != std::string::npos)
                    chatMsg.erase(0, pos + 3);

                trim(chatMsg);

                player_node->setSpeech(chatMsg, SPEECH_TIME);
            }
            else
            {
                if (localChatTab)
                    localChatTab->chatLog(chatMsg, ChatTab::BY_GM);
            }
            break;
        }

        case SMSG_MVP:
            // Display MVP player
            msg.readInt32(); // id
            if (localChatTab)
                localChatTab->chatLog(_("MVP player."), ChatTab::BY_SERVER);
            break;

        default:
            break;
    }
}

void ChatHandler::talk(const std::string &text)
{
    std::string mes = player_node->getName() + " : " + text;

    MessageOut outMsg(CMSG_CHAT_MESSAGE);
    // Added + 1 in order to let eAthena parse admin commands correctly
    outMsg.writeInt16(mes.length() + 4 + 1);
    outMsg.writeString(mes, mes.length() + 1);
}

void ChatHandler::me(const std::string &text)
{
    std::string action = strprintf("*%s*", text.c_str());

    talk(action);
}

void ChatHandler::privateMessage(const std::string &recipient,
                                 const std::string &text)
{
    MessageOut outMsg(CMSG_CHAT_WHISPER);
    outMsg.writeInt16(text.length() + 28);
    outMsg.writeString(recipient, 24);
    outMsg.writeString(text, text.length());
}

void ChatHandler::channelList()
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::enterChannel(const std::string &channel _UNUSED_,
                               const std::string &password _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::quitChannel(int channelId _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::sendToChannel(int channelId _UNUSED_, const std::string &text _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::userList(const std::string &channel _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::setChannelTopic(int channelId _UNUSED_, const std::string &text _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::setUserMode(int channelId _UNUSED_, const std::string &name _UNUSED_, int mode _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::kickUser(int channelId _UNUSED_, const std::string &name _UNUSED_)
{
    localChatTab->chatLog(_("Channels are not supported!"), ChatTab::BY_SERVER);
}

void ChatHandler::who()
{
    MessageOut outMsg(CMSG_WHO_REQUEST);
}

void ChatHandler::sendRaw(const std::string &args)
{
//    MessageOut outMsg(CMSG_CHAT_MESSAGE);
//    outMsg.writeInt16(mes.length() + 4 + 1);
//    outMsg.writeString(mes, mes.length() + 1);

    std::string line = args;
    std::string str;
    MessageOut *outMsg = NULL;

    if (line == "")
        return;

    std::string::size_type pos = line.find(" ");
    if (pos != std::string::npos)
    {
        str = line.substr(0, pos);
        outMsg = new MessageOut(atoi(str.c_str()));
        line = line.substr(pos + 1);
        pos = line.find(" ");
    }
    else
    {
        outMsg = new MessageOut(atoi(line.c_str()));
        return;
    }

    while (pos != std::string::npos)
    {
        str = line.substr(0, pos);
        processRaw(*outMsg, str);
        line = line.substr(pos + 1);
        pos = line.find(" ");
    }
    if (outMsg)
    {
        if (line != "")
        {
            processRaw(*outMsg, line);
        }
        delete outMsg;
    }
}

void ChatHandler::processRaw(MessageOut &outMsg, std::string &line)
{
    int i = atoi(line.c_str());
    if (line.length() <= 3)
        outMsg.writeInt8(i);
    else if (line.length() <= 5)
        outMsg.writeInt16(i);
    else
        outMsg.writeInt32(i);
}


} // namespace EAthena
